# Source code for api.system.components.runtime.v1.invoke

    """Autogenerated API"""
    import requests
    from argus_cli.plugin import register_command

    @register_command(extending=('system','components','runtime','v1','invoke'))
    def call(type: str = None, method: str = None, arguments: list = None,json: bool = True, verify: bool = True, apiKey: str = "", authentication: dict = {}) -> dict:
        """Invoke operation (INTERNAL)

        :param str type:
        :param str method:
        :param list arguments:
        :raises AuthenticationFailedException: on 401
        :raises ValidationErrorException: on 412
        :raises AccessDeniedException: on 403
        :returns: {"offset": 432, "limit": 378, "responseCode": 200, "count": 620, "metaData": {"additionalProperties": {}}, "messages": [{"message": "Kitchen authority discover according.", "messageTemplate": "Soon smile the list produce mouth.", "field": "Main open clearly however summer.", "parameter": {}, "timestamp": 1225949680}], "currentPage": 518, "size": 671}
        """
        from requests import put
        from argus_api.exceptions import http

        url = "https://osl-argus-trunk-web1.mnemonic.no/web/api/system/components/runtime/v1/invoke".format()
        headers = {
            'Content-Type': 'application/json',
            'User-Agent': 'ArgusToolbelt/1.0'
        }

        if apiKey:
            headers["Argus-API-Key"] = apiKey
        elif authentication and isinstance(authentication, dict):
            headers.update(authentication)
        elif callable(authentication):
            headers.update(authentication(url))

        body = {}

        if type:
            body.update({"type": type})

        if method:
            body.update({"method": method})

        if arguments:
            body.update({"arguments": arguments})

        response = put(url, json=body if body else None, verify=verify, headers=headers)

        errors = []
        if response.status_code == 401:
            raise http.AuthenticationFailedException(response)
        elif response.status_code == 403:
            raise http.AccessDeniedException(response)
        elif response.status_code == 412:
            raise http.ValidationErrorException(response)
        elif response.status_code == 404:
            raise http.ObjectNotFoundException(response)

        return response.json() if json else response